<template>
  <v-dialog v-model="dialog" max-width="500">
    <v-card>
      <v-card-title class="headline">Create Product</v-card-title>

      <v-card-text>
        <v-form v-model="valid">
          <v-list>
            <v-text-field label="Name" v-model="name"/>
            <v-currency-field label="Current Price" v-bind="currency_config" v-model="price"/>
          </v-list>
        </v-form>
      </v-card-text>

      <v-card-actions>
        <v-spacer></v-spacer>

        <v-btn color="red darken-1" flat="flat" @click="dialog = false" :loading="loading">Cancel</v-btn>
        <v-btn
          color="green darken-1"
          flat="flat"
          @click="createProduct(); dialog = false"
          :loading="loading"
        >Agree</v-btn>
      </v-card-actions>
    </v-card>
  </v-dialog>
</template>

<script>
import gql from "graphql-tag";

export default {
  props: {
    id: String
  },
  data() {
    return {
      valid: null,
      dialog: false,
      loading: false,
      currency_config: {
        decimal: ",",
        thousands: ".",
        prefix: "R$ ",
        precision: 2,
        masked: false,
        allowBlank: false,
        min: Number.MIN_SAFE_INTEGER,
        max: Number.MAX_SAFE_INTEGER
      },
      product: {
        name: "",
        price: 0
      }
    };
  },
  computed: {
    name: {
      get() {
        return this.product && this.product.name;
      },
      set(v) {
        this.product.name = v;
      }
    },
    price: {
      get() {
        return (this.product && this.product.price) / 100;
      },
      set(v) {
        this.product.price = v * 100;
      }
    }
  },
  methods: {
    open() {
      this.dialog = true;
    },
    async createProduct() {
      this.loading = true;

      try {
        await this.$apollo.mutate({
          mutation: gql`
            mutation($product: ProductInputCreate!) {
              productCreate(product: $product) {
                id
              }
            }
          `,
          variables: {
            product: this.product
          }
        });
      } catch (e) {
        console.error(e);
      } finally {
        this.loading = false;
      }
    }
  }
};
</script>
